<h1 id="ace">ACE</h1>
<p>Accessible Custom Elements (ACE) is a library of UI components that are accessible to users who rely on assistive technologies or keyboard navigation. ACE components have full keyboard support and all the required WAI-ARIA roles, states and properties specified in the <a href="https://www.w3.org/TR/wai-aria-practices-1.1">W3 WAI-ARIA Authoring Practices 1.1</a>.</p>
<p>The components all have minimal CSS styling applied to them that can be easily overridden making them compatible with almost any design system. Most of the components are provided in different variants that cover common use cases. This helps developers create rich, dynamic and creative websites that are also fully accessible for all users. More information about ACE can be found <a href="https://ace.p.ota.to/about">here</a>.</p>
<h2 id="installation">Installation</h2>
<p>The instructions below can be followed for using ACE components with JavaScript. Instructions for how to use ACE components with React, Angular and Vue can be found <a href="https://ace.p.ota.to/js-frameworks">here</a>.</p>
<p>To install all ACE components and the common files required by them run</p>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<p>or</p>
<pre><code class="language-bash">yarn add @potato/ace
</code></pre>
<p>To use a component import the class into your main JavaScript file:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/&lt;component-name&gt;/&lt;component-name&gt;';
</code></pre>
<p>Then import the component's SASS file into a SASS file in your project, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file, and <code>&lt;component-name&gt;</code> with the component name:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/&lt;component-name&gt;/&lt;component-name&gt;';
</code></pre>
<p>Alternatively, you can import the component's CSS file into a CSS file in your project:</p>
<pre><code class="language-css">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/&lt;component-name&gt;/&lt;component-name&gt;.css';
</code></pre>
<p>Specific instructions for how to use a particular component can be found on the component's webpage, along with live examples, or in the component's <em>README</em> file located at <em>&lt;path-to-node_modules&gt;/@potato/ace/&lt;component-name&gt;/READE.md</em>.</p>
<p>For example, the Accordion component instructions can be found on it's <a href="https://ace.p.ota.to/accordion">webpage</a> or in <em>&lt;path-to-node_modules&gt;/@potato/ace/accordion/README.md</em>.</p>
<h2 id="component-sass-variables">Component SASS variables</h2>
<p>ACE components define SASS variables using the <code>!default</code> keyword, allowing developers to easily configure component styles by simply assigning a value to the variable before importing the SASS file where the variable is defined.</p>
<p>For example, the selected option highlight color of the Listbox component can be changed as follows:</p>
<pre><code class="language-scss">/* Override ACE variable... */
$ace-listbox-selected-option-bg-color: #cccccc;

/* Then import SASS file where ACE variable is defined */
@import '&lt;path-to-node_modules&gt;/node_modules/@potato/ace/listbox/listbox';
</code></pre>
